// SetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VSMSGWDemo.h"
#include "SetupDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg dialog


CSetupDlg::CSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSetupDlg::IDD, pParent)
  , m_enable_crypt(FALSE)
{
	//{{AFX_DATA_INIT(CSetupDlg)
	m_gwip = _T("");
	m_gwkey = _T("");
	m_gwport = 0;
	m_mynodeid = 0;
	//}}AFX_DATA_INIT
}


void CSetupDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CSetupDlg)
  DDX_Control(pDX, IDC_SPINPORT, m_spinport);
  DDX_Text(pDX, IDC_GWIP, m_gwip);
  DDX_Text(pDX, IDC_GWKEY, m_gwkey);
  DDV_MaxChars(pDX, m_gwkey, 8);
  DDX_Text(pDX, IDC_GWPORT, m_gwport);
  DDV_MinMaxInt(pDX, m_gwport, 5000, 10000);
  DDX_Text(pDX, IDC_MYNODEID, m_mynodeid);
  //}}AFX_DATA_MAP
  DDX_Control(pDX, IDC_ENCRYPTIONKEY, c_cryptkey);
  DDX_Check(pDX, IDC_ENABLE, m_enable_crypt);
}


BEGIN_MESSAGE_MAP(CSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CSetupDlg)
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_ENABLE, &CSetupDlg::OnBnClickedEnable)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetupDlg message handlers

void CSetupDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CSetupDlg::OnOK() 
{
  // Get changed crypt key
  c_cryptkey.GetData(m_crypt_key, 16);

  CDialog::OnOK();
}

BOOL CSetupDlg::OnInitDialog() 
{
  CDialog::OnInitDialog();

  // Set crypt key
  c_cryptkey.m_bpr = 4;
  c_cryptkey.SetOptions(false, true, false, false);
  c_cryptkey.SetData(m_crypt_key, 16);

  // Disable cryptkey?
  if (!m_enable_crypt) {
    c_cryptkey.EnableWindow(FALSE);
  }

	// TODO: Add extra initialization here
  m_spinport.SetRange(5000, 10000);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSetupDlg::OnBnClickedEnable()
{
  // Update check state
  UpdateData(true);

  // Is cryptkey enablet?
  if (m_enable_crypt) {
    // Enable HexEdit
    c_cryptkey.EnableWindow(TRUE);
  } else {
    // Disable HexEdit
    c_cryptkey.EnableWindow(FALSE);
  }
}
